 MEMBER
 INCLUDE('lpt.inc'),ONCE
 INCLUDE('vsa_eprn.inc'),ONCE

HANDLE                  EQUATE(UNSIGNED)
LPCSTR                  EQUATE(CSTRING)    !Usage:Pass the Label of the LPCSTR
LPCTSTR                 EQUATE(LPCSTR)
HDC                     EQUATE(HANDLE)
LPSTR                   EQUATE(CSTRING)    !Usage:Pass the Label of the LPSTR
LPVOID                  EQUATE(ULONG)
DWORD                   EQUATE(ULONG)
LPHANDLE                EQUATE(HANDLE)
LPBOOL                  EQUATE(ULONG)
WORD                    EQUATE(SHORT)       ! Was UNSIGNED (4 Bytes) should be SHORT (2 BYTES)
HDC                     EQUATE(HANDLE)
HFONT                   EQUATE(HANDLE)
HGDIOBJ                 EQUATE(HANDLE)
HINSTANCE               EQUATE(HANDLE)
HWND                    EQUATE(HANDLE)
HGLOBAL                 EQUATE(HANDLE)
HBITMAP                 EQUATE(HANDLE)
NULL                    EQUATE('<00h>')

PRINTER_DEFAULTS        GROUP,TYPE
pDatatype                   LONG   !*PSTR
pDevMode                    LONG   !LPDEVMODE
DesiredAccess               DWORD
                        END

DOC_INFO_1              GROUP,TYPE
pDocName                    ULONG
pOutputFile                 ULONG
pDataType                   ULONG
                        END

PrinterInfo GROUP,TYPE
pPrinterName LONG
pPortName LONG
Attributes LONG
NotSelectedTimeout LONG
RetryTimeout LONG
   END

vs APIPrinterClass


 MAP
   MODULE('Windows API')
     EnumPrintersA(DWORD,<*LPSTR>,DWORD,LONG,DWORD,*LONG,*LONG),BOOL,PASCAL,RAW
     OpenPrinterA(*LPSTR,*HANDLE,*PRINTER_DEFAULTS),BOOL,PASCAL,RAW
     StartDocPrinterA(HANDLE,DWORD,*BYTE),DWORD,PASCAL
     StartPagePrinter(HANDLE),BOOL,PASCAL
     WritePrinter(HANDLE,LPVOID,DWORD,*DWORD),BOOL,PASCAL,RAW
     EndPagePrinter(HANDLE),BOOL,PASCAL,PROC
     EndDocPrinter(HANDLE),BOOL,PASCAL,PROC
     ClosePrinter(HANDLE),BOOL,PASCAL,PROC
     END
 END

LPT.Open PROCEDURE(*CSTRING pPrinterName)
PN CSTRING(256)
   CODE
      LOOP
         IF SELF.TryOpen(pPrinterName) THEN BREAK END
         PN = SELF.PickOne()
         IF PN = '' THEN RETURN FALSE END
         pPrinterName = PN
         END
     

LPT.TryOpen PROCEDURE(STRING pPrinterName)
hPrinter            HANDLE
szPrinterName       LPSTR(80)
dwJob               DWORD
DocInfo             LIKE(DOC_INFO_1)
DocDefaults         LIKE(PRINTER_DEFAULTS)
lpDocInfo           BYTE,DIM(SIZE(DocDefaults)),OVER(DocDefaults)

    CODE
      szPrinterName = CLIP(pPrinterName)
      CLEAR(DocDefaults)     
      IF NOT OpenPrinterA( szPrinterName, hPrinter, DocDefaults ) THEN RETURN(FALSE) END
      CLEAR(DocInfo)
      DocInfo.pDocName = 'Receipt Printer'
      DocInfo.pDataType = 'RAW'
      DocInfo.pOutputFile = NULL
      dwJob = StartDocPrinterA ( hPrinter, 1, lpDocInfo[1])

      IF NOT dwJob THEN
       ClosePrinter(hPrinter)
       RETURN FALSE
       END

      IF NOT StartPagePrinter( hPrinter ) THEN
       EndDocPrinter( hPrinter )
       ClosePrinter( hPrinter )
       RETURN FALSE
       END
    SELF.PrinterHandle = hPrinter ! Save the handle for other modules to use
    RETURN(TRUE)


LPT.WriteBn PROCEDURE(STRING pS, LONG pLength) !Write regardless of contents
lpBuffer LPVOID
dwcount DWORD
dwBytesWritten DWORD

   CODE
      IF NOT SELF.PrinterHandle THEN RETURN END
      lpBuffer = ADDRESS(pS)
      dwCount = pLength
      dwBytesWritten = 0
      IF NOT WritePrinter(SELF.PrinterHandle,lpBuffer,dwCount,dwBytesWritten) THEN END

LPT.BarCode PROCEDURE( STRING pS)
lS STRING(128)
I LONG
   CODE
      ls = '<29><104><81>'
      SELF.WriteBn(ls,3)
      lS = '<29><107><69>' & CHR(LEN(CLIP(PS))) & CLIP(PS)
      SELF.WriteBn(lS,LEN(CLIP(PS))+4)

LPT.Write PROCEDURE(STRING pS)
szBuffer        LPSTR(132)
lpBuffer        LPVOID
dwCount         DWORD
dwBytesWritten  DWORD

   CODE
      IF NOT SELF.PrinterHandle THEN RETURN END
      szBuffer        = pS
      lpBuffer        = ADDRESS(szBuffer)
      dwCount         = LEN(szBuffer)
      dwBytesWritten  = 0

    IF NOT WritePrinter (SELF.PrinterHandle, lpBuffer, dwCount, dwBytesWritten) THEN END

LPT.WriteLn PROCEDURE(STRING pS)
   CODE
      SELF.Write(pS & '<13,10>')

LPT.Close PROCEDURE()
   CODE
    EndPagePrinter(SELF.PrinterHandle)     ! Tell the Spooler to End the Page
    EndDocPrinter(SELF.PrinterHandle)     ! Tell the Spooler to End the Document
    ClosePrinter(SELF.PrinterHandle)     ! Tell the Printer the Job is Finished
    SELF.PrinterHandle = 0

LPT.Cut PROCEDURE(BYTE pLines)
   CODE
      LOOP
         IF pLines = 0 THEN BREAK END
         SELF.WriteLn('')
         pLines -= 1
         END
      SELF.WriteBn('<27,105>',2)

LPT.KickDrawer PROCEDURE( BYTE pDrawer)
   CODE
      SELF.Write('<27>p' & pDrawer-1 & '<75><100>')

LPT.Color PROCEDURE(BYTE pColor) ! 0 = Black 5 = Red
S3 STRING('<27>r ')
   CODE
      S3[3] = CHR(pColor)
      SELF.WriteBn(S3,3)

LPT.AlignLeft PROCEDURE
   CODE
      SELF.WriteBn('<27>a<0>',3)

LPT.AlignRight PROCEDURE
   CODE
      SELF.WriteBn('<27>a<2>',3)

LPT.AlignCenter PROCEDURE
   CODE
      SELF.WriteBn('<27>a<1>',3)

LPT.Bold PROCEDURE(BYTE pOn) ! TRUE = Bold, FALSE = Normal
   CODE
      IF pON
         SELF.WriteBn('<27>E<1>',3)
      ELSE
         SELF.WriteBn('<27>E<0>',3)
         END

LPT.PrintLogo PROCEDURE(BYTE pLogo)
S4 STRING(4)

   CODE
      S4 = '<28><112><1><0>'
      S4[3] = CHR(pLogo)
      SELF.WriteBn(S4,4)

LPT.Mode PROCEDURE(BYTE pFont, BYTE pHeight, BYTE pWidth, BYTE pPro) ! Double(FALSE,FALSE) for normal
S3 STRING('<27><33><0>')
V BYTE
   CODE
     V = 0
     IF pFont THEN V += 1 END
     IF pHeight THEN V += 16 END
     IF pWidth THEN V += 32 END
     IF pPro THEN V += 2 END
     S3[3] = CHR(V)
     SELF.WriteBn(S3,3)

LPT.PickOne PROCEDURE()
PQ tPrinterQ
PN CSTRING(256)
WND  WINDOW('Select Printer'),AT(,,200,250),WALLPAPER('C:\CSSQLSDK\V6\Images\grayfade.gif'),SYSTEM,GRAY, |
         DOUBLE
       STRING('Can''t find receipt printer. Please pick one:'),AT(1,2),USE(?String1),TRN,FONT(,,COLOR:White,,CHARSET:ANSI)
       LIST,AT(1,13,198,207),USE(?List1),VSCROLL,FONT('MS Sans Serif',14,,),FORMAT('20L(2)|M~Printer~@S255@'), |
           FROM(PQ)
       BUTTON('Select'),AT(2,224,51,23),USE(?Button1),LEFT,ICON('C:\CSSQLSDK\V6\Images\select.gif')
     END
   CODE
   IF vs.GetPrinterList(PQ) THEN END
   OPEN(Wnd)
   Accept
      CASE EVENT() 
         OF EVENT:Accepted
            CASE FIELD()
               OF ?Button1
                  GET(PQ,CHOICE(?List1))
                  PN = PQ.PrinterName
                  BREAK
               END
         END
      END
   CLOSE(Wnd)
   RETURN PN


LPT.FindOne PROCEDURE(STRING pPrinterName)
PQ tPrinterQ
PN STRING(80)
   CODE
   PN = pPrinterName
   IF vs.GetPrinterList(PQ) THEN END
   GET(PQ,1)
   LOOP
      IF ERRORCODE() THEN BREAK END
      IF INSTRING(pPrinterName,PQ.ShowName,1,1) THEN PN = PQ.ShowName END
      GET(PQ,POINTER(PQ)+1)
      END
   FREE(PQ)
   RETURN PN

LPT.Reset PROCEDURE()
   CODE
      SELF.Write('<27>@')